unit fScriptEngine2;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, ScrMemo, ScrMps, IDEDialog,
  atScript, atScripter, IDEMain, Vcl.StdCtrls, ComponentInspector,
  Vcl.ExtCtrls, Vcl.CategoryButtons, Vcl.ComCtrls, ScrMbs,
  Vcl.Imaging.pngimage, Vcl.Menus, SynEditHighlighter, SynHighlighterPas,
  dIDEActions, Vcl.ScripterInit, FSearch, InspectorControls;

type
  TFormScriptEngine2 = class(TForm)
    ScriptEngine: TIDEEngine;
    Scripter: TIDEScripter;
    PascalStyle: TScrPascalMemoStyler;
    Inspector: TIDEInspector;
    TabScripts: TTabControl;
    FormDesigner: TIDEFormDesignControl;
    Memo: TIDEMemo;
    ComponentComboBox: TIDEComponentComboBox;
    ComponentPalette: TIDEPaletteButtons;
    WatchList: TIDEWatchListView;
    MemoPopupMenu: TPopupMenu;
    Undo1: TMenuItem;
    N1: TMenuItem;
    Cut1: TMenuItem;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    Delete1: TMenuItem;
    N2: TMenuItem;
    SelectAll1: TMenuItem;
    N3: TMenuItem;
    CopyasHTML1: TMenuItem;
    AddWatch1: TMenuItem;
    AddB1: TMenuItem;
    Debug1: TMenuItem;
    Compile1: TMenuItem;
    Run1: TMenuItem;
    PopupMenuNew: TPopupMenu;
    NewUnit1: TMenuItem;
    NewForm1: TMenuItem;
    N4: TMenuItem;
    NewProject1: TMenuItem;
    SourceToolbar: TPanel;
    BInspectorEvents: TButton;
    BInspectorProperties: TButton;
    BSearch: TButton;
    BReplace: TButton;
    FindDialog: TScrMemoFindDialog;
    ReplaceDialog: TScrMemoFindReplaceDialog;
    BNew: TButton;
    BOpen: TButton;
    BSave: TButton;
    BRun: TButton;
    DesignerMenu: TPopupMenu;
    Cut2: TMenuItem;
    Copy2: TMenuItem;
    Paste2: TMenuItem;
    N5: TMenuItem;
    N6: TMenuItem;
    SelectAll2: TMenuItem;
    N7: TMenuItem;
    SendtoBack1: TMenuItem;
    BringtoFront1: TMenuItem;
    BShowForm: TButton;
    BAddUnit: TButton;
    BRemoveUnit: TButton;
    BStop: TButton;
    Stop1: TMenuItem;
    N8: TMenuItem;
    BToggleBrakepoint: TButton;
    DesignerToolbar: TPanel;
    BShowSource: TButton;
    MemoMessages: TIDEMemo;
    FileSearchHelperScripts: TFileSearch;
    N9: TMenuItem;
    CloseAll1: TMenuItem;
    N10: TMenuItem;
    ExpandNodes1: TMenuItem;
    CollapseNodes1: TMenuItem;
    ShowCodeFolding: TMenuItem;
    N11: TMenuItem;
    ShowTabOrder1: TMenuItem;
    N12: TMenuItem;
    ToggleCodeInsight1: TMenuItem;
    StepOver1: TMenuItem;
    TraceInto1: TMenuItem;
    DebugReset1: TMenuItem;
    N13: TMenuItem;
    ClearAllBrakepoint1: TMenuItem;
    FileSearchEditorScripts: TFileSearch;
    StatusBar: TStatusBar;
    APanel: TPanel;
    Panel1: TPanel;
    ABPanel: TPanel;
    Panel2: TPanel;
    procedure BRunClick(Sender: TObject);
    procedure BOpenClick(Sender: TObject);
    procedure BSaveClick(Sender: TObject);
    procedure ComponentPaletteDrawIcon(Sender: TObject;
      const Button: TButtonItem; Canvas: TCanvas; Rect: TRect;
      State: TButtonDrawState; var TextOffset: Integer);
    procedure Undo1Click(Sender: TObject);
    procedure Cut1Click(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure CopyasHTML1Click(Sender: TObject);
    procedure Paste1Click(Sender: TObject);
    procedure Delete1Click(Sender: TObject);
    procedure SelectAll1Click(Sender: TObject);
    procedure AddWatch1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Compile1Click(Sender: TObject);
    procedure Run1Click(Sender: TObject);
    procedure NewProject1Click(Sender: TObject);
    procedure NewUnit1Click(Sender: TObject);
    procedure NewForm1Click(Sender: TObject);
    procedure ScriptEngineViewModeChanged(Sender: TObject);
    procedure BInspectorPropertiesClick(Sender: TObject);
    procedure BInspectorEventsClick(Sender: TObject);
    procedure BNewClick(Sender: TObject);
    procedure BSearchClick(Sender: TObject);
    procedure BReplaceClick(Sender: TObject);
    procedure Copy2Click(Sender: TObject);
    procedure Cut2Click(Sender: TObject);
    procedure Paste2Click(Sender: TObject);
    procedure SelectAll2Click(Sender: TObject);
    procedure SendtoBack1Click(Sender: TObject);
    procedure BringtoFront1Click(Sender: TObject);
    procedure BShowFormClick(Sender: TObject);
    procedure BAddUnitClick(Sender: TObject);
    procedure BRemoveUnitClick(Sender: TObject);
    procedure BStopClick(Sender: TObject);
    procedure Stop1Click(Sender: TObject);
    procedure BToggleBrakepointClick(Sender: TObject);
    procedure AddB1Click(Sender: TObject);
    procedure BShowSourceClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
    procedure CloseAll1Click(Sender: TObject);
    procedure CollapseNodes1Click(Sender: TObject);
    procedure ExpandNodes1Click(Sender: TObject);
    procedure ShowCodeFoldingClick(Sender: TObject);
    procedure ShowTabOrder1Click(Sender: TObject);
    procedure ToggleCodeInsight1Click(Sender: TObject);
    procedure TabScriptsChange(Sender: TObject);
    procedure StepOver1Click(Sender: TObject);
    procedure TraceInto1Click(Sender: TObject);
    procedure DebugReset1Click(Sender: TObject);
    procedure MemoKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure MemoCursorChange(Sender: TObject);
    procedure MemoTopLeftChanged(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
  private
    { Private declarations }
    procedure UpdateStatusBar;
    procedure ScriptMenuClick(Sender: TObject);
    procedure ScriptEditorInsertMenuClick(Sender: TObject);
  public
    { Public declarations }
    FLoaded: Boolean;

  end;

var
  FormScriptEngine2: TFormScriptEngine2;

implementation

{$R *.dfm}

uses fIDEEditor;




procedure TFormScriptEngine2.TabScriptsChange(Sender: TObject);
begin
  Memo.Gutter.GutterColor := $001E1E1E;
  Memo.Gutter.GutterColorTo := $001E1E1E;
end;

procedure TFormScriptEngine2.ScriptEditorInsertMenuClick(Sender: TObject);
var Cnt: Integer;
begin
end;

procedure TFormScriptEngine2.ScriptMenuClick(Sender: TObject);
var Cnt: Integer;
begin
end;

procedure TFormScriptEngine2.AddB1Click(Sender: TObject);
begin
  ScriptEngine.DebugToggleBreak();
end;

procedure TFormScriptEngine2.AddWatch1Click(Sender: TObject);
begin
  ScriptEngine.DlgAddWatch;
end;

procedure TFormScriptEngine2.CloseAll1Click(Sender: TObject);
begin
  ScriptEngine.DlgCloseAll;
end;

procedure TFormScriptEngine2.CollapseNodes1Click(Sender: TObject);
begin
  Memo.CollapseAllNodes;
end;

procedure TFormScriptEngine2.Compile1Click(Sender: TObject);
begin
  ScriptEngine.CompileProject;
  if Scripter.Compiled = True then begin
    ShowMessage('@Success, script was compiled.');
  end else begin
    ShowMessage('@Error, script was not compiled.');
  end;
end;

procedure TFormScriptEngine2.ComponentPaletteDrawIcon(Sender: TObject;
  const Button: TButtonItem; Canvas: TCanvas; Rect: TRect;
  State: TButtonDrawState; var TextOffset: Integer);
begin
  Button.ImageIndex := 0;
end;

procedure TFormScriptEngine2.Copy1Click(Sender: TObject);
begin
  Memo.CopyToClipBoard;
end;

procedure TFormScriptEngine2.Copy2Click(Sender: TObject);
begin
  ScriptEngine.Designer.CopyToClipboard;
end;

procedure TFormScriptEngine2.CopyasHTML1Click(Sender: TObject);
begin
  Memo.CopyHTMLToClipboard;
end;

procedure TFormScriptEngine2.Cut1Click(Sender: TObject);
begin
  Memo.CutToClipBoard;
end;

procedure TFormScriptEngine2.Cut2Click(Sender: TObject);
begin
  ScriptEngine.Designer.CutToClipboard;
end;

procedure TFormScriptEngine2.DebugReset1Click(Sender: TObject);
begin
  ScriptEngine.DebugReset;
end;

procedure TFormScriptEngine2.Delete1Click(Sender: TObject);
begin
  Memo.DeleteSelection;
end;

procedure TFormScriptEngine2.ExpandNodes1Click(Sender: TObject);
begin
  Memo.ExpandAllNodes;
end;

procedure TFormScriptEngine2.FormActivate(Sender: TObject);
begin
  Memo.Gutter.GutterColor := $001E1E1E;
  Memo.Gutter.GutterColorTo := $001E1E1E;
end;

procedure TFormScriptEngine2.FormCreate(Sender: TObject);
begin
  FileSearchHelperScripts.SearchPath := ExtractFileDir(Application.ExeName) + '\Scripts\MetrusCRS.ScriptEngineHelpers\';
  FileSearchHelperScripts.Search;

  FileSearchEditorScripts.SearchPath := ExtractFileDir(Application.ExeName) + '\Scripts\MetrusCRS.ScriptEngineEditorScripts\';
  FileSearchEditorScripts.Search;

  // Editor extra settings since it does not work straigt from properties
  Memo.SelBkColor := $000080FF;
  Memo.SelColor := clBlack;
  Memo.BkColor := $001E1E1E;

  Memo.Gutter.LineNumberTextColor := clSilver;
  Memo.Gutter.GutterColor := $001E1E1E;
  Memo.Gutter.GutterColorTo := $001E1E1E;

  Memo.CodeFolding.Enabled := True;
  ShowCodeFolding.Checked := Memo.CodeFolding.Enabled;
end;

procedure TFormScriptEngine2.FormDeactivate(Sender: TObject);
begin
  Memo.Gutter.GutterColor := $001E1E1E;
  Memo.Gutter.GutterColorTo := $001E1E1E;
end;

procedure TFormScriptEngine2.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Shift = [ssCtrl]) and (Key = VK_F9) then Compile1Click(Sender);
  if (Shift = [ssCtrl]) and (Key = $5A) then Undo1Click(Sender); // CTLR+Z Undo
  if (Shift = [ssCtrl]) and (Key = $43) then Copy1Click(Sender); // CTRL+C Copy
  if (Shift = [ssCtrl]) and (Key = $56) then Paste1Click(Sender); // CTRL+V Paste
  if (Shift = [ssCtrl]) and (Key = $49) then ToggleCodeInsight1Click(Sender); // CTRL+I Toggle Code Insight
  if (Shift = [ssCtrl]) and (Key = $46) then ShowCodeFoldingClick(Sender); // CTRL+F Show Code Folding
  if (Shift = [ssCtrl]) and (Key = $6B) then ExpandNodes1Click(Sender); // CTRL+NUM+ Expand Code Folding
  if (Shift = [ssCtrl]) and (Key = $6D) then CollapseNodes1Click(Sender); // CTRL+NUM- Collapse Code Folding
  if (Shift = [ssCtrl]) and (Key = $42) then AddB1Click(Sender); // CTRL+B Toggle Breakpoint
  if (Shift = [ssCtrl]) and (Key = $71) then DebugReset1Click(Sender); // CTRL+F2 Debug Reset
  if (Shift = [ssCtrl]) and (Key = $50) then Inspector.Mode := imProperties;; // CTRL+P Show Properties
  if (Shift = [ssCtrl]) and (Key = $45) then Inspector.Mode := imEvents; // CTRL+E Show Events
  if (Shift = [ssCtrl]) and (Key = $4E) then NewProject1Click(Sender); // CTRL+N New Project
  if (Shift = [ssCtrl]) and (Key = $4F) then BOpenClick(Sender); // CTRL+O Open Script Project
  if (Shift = [ssCtrl]) and (Key = $53) then BSaveClick(Sender); // CTRL+S Save All Scripts and Project
  if (Shift = [ssCtrl]) and (Key = $58) then CloseAll1Click(Sender); // CTRL+X Close All Scripts and Project

  if (Shift = []) and (Key = VK_F9) then Run1Click(Sender); // F9 Run Script
  if (Shift = []) and (Key = VK_F8) then StepOver1Click(Sender); // F8 Step Over
  if (Shift = []) and (Key = VK_F7) then TraceInto1Click(Sender); // F7 Trace Into
  if (Shift = []) and (Key = VK_F12) then begin
    if ScriptEngine.ActiveFile.ViewMode = vmForm then ScriptEngine.ActiveFile.ViewMode := vmUnit
    else ScriptEngine.ActiveFile.ViewMode := vmForm;
  end;
end;

procedure TFormScriptEngine2.FormShow(Sender: TObject);
begin
  Memo.Gutter.GutterColor := $001E1E1E;
  Memo.Gutter.GutterColorTo := $001E1E1E;
end;

procedure TFormScriptEngine2.MemoCursorChange(Sender: TObject);
begin
  UpdateStatusBar;
end;

procedure TFormScriptEngine2.MemoKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
   PopupPoint : TPoint;
begin
  if (ssCtrl in Shift) then begin
    //k := UpCAse(char(Key));
    //if k = '`' then begin
    if (Key = $31)then begin
      //PopupPoint := Mouse.CursorPos;
      GetCaretPos(PopupPoint);
    end
  end;
end;

procedure TFormScriptEngine2.MemoTopLeftChanged(Sender: TObject);
begin
  UpdateStatusBar;
end;

procedure TFormScriptEngine2.BShowSourceClick(Sender: TObject);
begin
  ScriptEngine.ActiveFile.ViewMode := vmUnit;
  Memo.AutoCodeFold;
  ShowCodeFolding.Checked := Memo.CodeFolding.Enabled;
  Memo.Gutter.GutterColor := $001E1E1E;
  Memo.Gutter.GutterColorTo := $001E1E1E;
end;

procedure TFormScriptEngine2.BInspectorPropertiesClick(Sender: TObject);
begin
  Inspector.Mode := imProperties;
end;

procedure TFormScriptEngine2.BSearchClick(Sender: TObject);
begin
  FindDialog.Execute;
end;

procedure TFormScriptEngine2.BShowFormClick(Sender: TObject);
begin
  ScriptEngine.ActiveFile.ViewMode := vmForm;
end;

procedure TFormScriptEngine2.BStopClick(Sender: TObject);
begin
  ScriptEngine.Scripter.Halt;
end;

procedure TFormScriptEngine2.BToggleBrakepointClick(Sender: TObject);
begin
  ScriptEngine.DebugToggleBreak();
end;

procedure TFormScriptEngine2.BRemoveUnitClick(Sender: TObject);
begin
  ScriptEngine.DlgRemoveActiveFile;
end;

procedure TFormScriptEngine2.BReplaceClick(Sender: TObject);
begin
  ReplaceDialog.Execute;
end;

procedure TFormScriptEngine2.BringtoFront1Click(Sender: TObject);
begin
  ScriptEngine.Designer.BringControlsToFront;
end;

procedure TFormScriptEngine2.BOpenClick(Sender: TObject);
begin
  Scripter.Free;
  Scripter := TIDEScripter.Create(Self);
  ScriptEngine.Scripter := Scripter;
  ScriptEngine.PaletteButtons := nil;

  // Script Engine Form Main Script Engine

  ScriptEngine.PaletteButtons := ComponentPalette;
  ScriptEngine.DlgOpenProject;
  Memo.AutoCodeFold;
  ShowCodeFolding.Checked := Memo.CodeFolding.Enabled;
end;

procedure TFormScriptEngine2.BSaveClick(Sender: TObject);
begin
  ScriptEngine.DlgSaveProject;
  ScriptEngine.DlgSaveAll;
  ScriptEngine.SaveProject;
  Memo.AutoCodeFold;
  ShowCodeFolding.Checked := Memo.CodeFolding.Enabled;
end;

procedure TFormScriptEngine2.BRunClick(Sender: TObject);
begin
  ScriptEngine.Scripter.Halt;
  ScriptEngine.RunProject;
end;

procedure TFormScriptEngine2.BNewClick(Sender: TObject);
var
   PopupPoint : TPoint;
begin
  PopupPoint := Mouse.CursorPos;
  PopupMenuNew.Popup(PopupPoint.X, PopupPoint.Y) ;
end;

procedure TFormScriptEngine2.BAddUnitClick(Sender: TObject);
begin
  ScriptEngine.DlgOpenFile;
end;

procedure TFormScriptEngine2.BInspectorEventsClick(Sender: TObject);
begin
  Inspector.Mode := imEvents;
end;

procedure TFormScriptEngine2.NewForm1Click(Sender: TObject);
begin
  ScriptEngine.NewFormUnit(slPascal);
end;

procedure TFormScriptEngine2.NewProject1Click(Sender: TObject);
begin
  ScriptEngine.DlgCloseAll;
  ScriptEngine.CreateMainUnits(slPascal);
end;

procedure TFormScriptEngine2.NewUnit1Click(Sender: TObject);
begin
  ScriptEngine.NewUnit(slPascal, True);
end;

procedure TFormScriptEngine2.ToggleCodeInsight1Click(Sender: TObject);
begin
  Memo.AutoCompletion.Active := not Memo.AutoCompletion.Active;
  ToggleCodeInsight1.Checked := Memo.AutoCompletion.Active;
end;

procedure TFormScriptEngine2.Paste1Click(Sender: TObject);
begin
  Memo.PasteFromClipBoard;
end;

procedure TFormScriptEngine2.Paste2Click(Sender: TObject);
begin
  ScriptEngine.Designer.PasteFromClipboard;
end;

procedure TFormScriptEngine2.TraceInto1Click(Sender: TObject);
begin
  ScriptEngine.DebugTraceInto();
end;

procedure TFormScriptEngine2.Run1Click(Sender: TObject);
begin
  ScriptEngine.Scripter.Halt;
  ScriptEngine.RunProject;
end;

procedure TFormScriptEngine2.ScriptEngineViewModeChanged(Sender: TObject);
begin
  if ScriptEngine.ActiveFile.ViewMode = vmForm then begin
    SourceToolbar.Visible := False;
    DesignerToolbar.Visible := True;
  end else begin
    DesignerToolbar.Visible := False;
    SourceToolbar.Visible := True;
    if ScriptEngine.ActiveFile.Form <> nil then BShowForm.Visible := True else
    BShowForm.Visible := False;
  end;
end;

procedure TFormScriptEngine2.SelectAll1Click(Sender: TObject);
begin
  Memo.SelectAll;
end;

procedure TFormScriptEngine2.SelectAll2Click(Sender: TObject);
begin
  ScriptEngine.Designer.SelectAll;
end;

procedure TFormScriptEngine2.SendtoBack1Click(Sender: TObject);
begin
  ScriptEngine.Designer.SendControlsToBack;
end;

procedure TFormScriptEngine2.ShowCodeFoldingClick(Sender: TObject);
begin
  Memo.AutoCodeFold;
  ShowCodeFolding.Checked := Memo.CodeFolding.Enabled;
end;

procedure TFormScriptEngine2.ShowTabOrder1Click(Sender: TObject);
begin
  ScriptEngine.Designer.TabOrderDialog;
end;

procedure TFormScriptEngine2.StepOver1Click(Sender: TObject);
begin
  ScriptEngine.DebugStepOver();
end;

procedure TFormScriptEngine2.Stop1Click(Sender: TObject);
begin
  ScriptEngine.Scripter.Halt;
end;

procedure TFormScriptEngine2.Undo1Click(Sender: TObject);
begin
  Memo.Undo;
end;

procedure TFormScriptEngine2.UpdateStatusBar;
begin
  StatusBar.SimpleText := 'X: ' + IntToStr(Memo.CurX + 1) + '  Y:'+  IntToStr(Memo.CurY + 1);
end;

end.
